/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mapping are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2003 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */
package org.objectweb.jorm.mapper.rdb.adapter;

/**
 * This class is a sql adapter for the Sybase relational database.
 * @author S.Chassande-Barrioz
 */
public class SybaseAdapter extends BasicRdbAdapter {

	public SybaseAdapter() {
		super("sybase");
	}

	public void writeTableAlias(String alias, StringBuffer sb) {
		sb.append(" ");
		sb.append(alias);
	}
	
    protected void modifySelectClauseWithRange(StringBuffer sb, boolean rangeStart,
            boolean rangeSize) {
        if (rangeSize || rangeStart) {
            StringBuffer begin = new StringBuffer();
	        if (rangeSize) {
	            begin.append(" TOP ? ");
	        } else {
                begin.append(" TOP " + String.valueOf(Integer.MAX_VALUE));
            }
	        if (rangeStart) {
	            begin.append (" START ? ");
	        }
	        sb.indexOf(begin.toString(), 7); //7="SELECT ".length()
        }
    }

    protected void modifyQueryWithRange(StringBuffer sb, boolean rangeStart,
            boolean rangeSize) {
        // Do nothing
    }

    public int getRangeParametersAtStart() {
        return RANGEATSTART;
    }	
}
