/**
 * Speedo: an implementation of JDO compliant personality on top of JORM generic
 * I/O sub-system.
 * Copyright (C) 2001-2004 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *
 * Contact: speedo@objectweb.org
 *
 */

package org.objectweb.jorm.mapper.rdb.adapter.api;

import java.util.List;

/**
 * Adapter for index management.
 * 
 * @author Y.Bersihand
 */
public interface IndexAdapter {
	/**
	 * 
	 * @param name the name of the index
	 * @param tableName the name of the table
	 * @return the sql statement to drop the index
	 * @throws UnsupportedOperationException
	 */
	String getDropIndex(String name, String tableName)
		throws UnsupportedOperationException;
	
	/**
	 * 
	 * @param name the name of the index
	 * @param tableName the name of the table
	 * @param fieldNames names of fields 
	 * @param if unique, fieldNames is a key for the table
	 * @return the sql statement to create the index
	 * @throws UnsupportedOperationException
	 */
	String getCreateIndex(String name, String tableName, List fieldNames, boolean unique)
	throws UnsupportedOperationException;
	
}
